VCMD0028040800000000COMPONENT          
Node "rSimResource"
{
Name "DesktopPlayer"
Id 1
NodeClass 
{
Id 1
Feature "rTransformFeature"
{
Name "Transform"

Visible 1
VariableSpace
{
  Variable "rTVariable<rString>"
  {
    Name "Name"
    Value "Transform"
    Group 0
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rBool>"
  {
    Name "Visible"
    Value 1
    Group 1
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTExpressionVariable<rMatrix>"
  {
    Name "Expression"
    Value
    {
      Expression "Sx(Scale).Sy(Scale).Sz(Scale)"
    }
    Group 2
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      ON_EDIT_REBUILD
      MANAGED
    }
  }
}
Transform 
{
  Expression "Sx(Scale).Sy(Scale).Sz(Scale)"
}

Feature "rGeoFeature"
{
Name "Block"

Visible 1
VariableSpace
{
  Variable "rTVariable<rString>"
  {
    Name "Name"
    Value "Block"
    Group 0
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rBool>"
  {
    Name "Visible"
    Value 1
    Group 1
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rUri>"
  {
    Name "Uri"
    Value "geo-61fc313e-d8ba-439d-bb80-53882ddf9e57"
    Group 2
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      ON_EDIT_REBUILD
      MANAGED
    }
  }
  Variable "rTVariable<rBool>"
  {
    Name "OnDemandLoad"
    Value 0
    Group 3
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      ON_EDIT_REBUILD
      MANAGED
    }
  }
  Variable "rTVariable<rBool>"
  {
    Name "ShowContent"
    Value 1
    Group 4
    Settings
    {
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      ON_EDIT_REBUILD
      MANAGED
    }
  }
  Variable "rTVariable<rBool>"
  {
    Name "ShowBackfaces"
    Value 0
    Group 5
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      ON_EDIT_REBUILD
      MANAGED
    }
  }
  Variable "rTVariable<rDouble>"
  {
    Name "CreaseAngle"
    Value 45
    Group 6
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      ON_EDIT_REBUILD
      MANAGED
    }
    Quantity "Angle" "VectorQuantity"
    {
      Groups
      {
        UnitGroup "eaf"
        {
          Unit
          {
            Name "ht"
            Suffix "rwhjrt"
            Factor 1
            Offset 0
          }
          Family "US degrees"
        }
        UnitGroup "Anzahl"
        {
          Unit
          {
            Name "Stück"
            Suffix "Stk"
            Factor 1
            Offset 0
          }
          Family "Count"
          Family "Position"
        }
        UnitGroup "Euro"
        {
          Family "Test"
        }
      }
    }
    Magnitude 1
  }
  Variable "rTEnumVariable<rInt>"
  {
    Name "AmbientOcclusion"
    Value 0
    Group 7
    Settings
    {
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      ON_EDIT_REBUILD
      MANAGED
    }
    StepList
    {
      Step
      {
        Value 0
        Enabled 1
        Description "None"
      }
      Step
      {
        Value 1
        Enabled 1
        Description "Vertex"
      }
      Step
      {
        Value 2
        Enabled 1
        Description "Texture"
      }
    }
  }
  Variable "rTVariable<rBool>"
  {
    Name "Pickable"
    Value 1
    Group 8
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      ON_EDIT_REBUILD
      MANAGED
    }
  }
  Variable "rTVariable<rDouble>"
  {
    Name "BrepChordHeightRatio"
    Value -1
    Group 9
    Settings
    {
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rDouble>"
  {
    Name "BrepAngleToleranceDeg"
    Value -1
    Group 10
    Settings
    {
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rDouble>"
  {
    Name "BrepAngleToleranceDegCurves"
    Value -1
    Group 11
    Settings
    {
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rDouble>"
  {
    Name "BrepChordHeightRatioCurves"
    Value -1
    Group 12
    Settings
    {
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
      TRANSLATE_USING_GETTEXT
    }
  }
}

Uri "geo-61fc313e-d8ba-439d-bb80-53882ddf9e57"
OnDemandLoad 0
UseBackfaces 0
MaterialInheritance "Disabled"
}
}
VCID "f593a259-70a8-482a-925f-06ef7c71bc3d"
}
Functionality "rPythonScript"
{
Id 1
Name "PythonScript"
Visible 1
Script "from vcScript import *\nfrom PIL import ImageGrab
\nfrom ctypes import windll, wintypes, byref
\nimport time, vcVector
\nfrom datetime import datetime
\n
\napp = getApplication()
\nsim = getSimulation()
\ncomp = getComponent()
\n  
\ndef OnRun():
\n  # New block
\n  transform = comp.findFeature(\"Transform\")
\n  if transform:
\n    transform.delete()
\n  transform = comp.RootFeature.createFeature(VC_TRANSFORM, \"Transform\")
\n  transform.Expression = \"Sx(Scale).Sy(Scale).Sz(Scale)\"  
\n  
\n  # Define size
\n  imageWidth = comp.Right - comp.Left
\n  imageHeight = comp.Bottom - comp.Top
\n  block = transform.createFeature(VC_BLOCK, \"Block\")
\n  block.Length = \"%i {mm}\" % imageWidth
\n  block.Width = \"0.0 {mm}\"
\n  block.Height = \"%i {mm}\" % imageHeight  
\n  block.collapse()
\n  
\n  # Set block
\n  block = comp.findFeature(\"Block\")  
\n  geometry = block.Geometry.GeometrySets[0]
\n  for pointIndex in range(geometry.PointCount):    
\n    vector = geometry.getPoint(pointIndex)
\n    u = (vector.X / imageWidth)
\n    v = (vector.Z / imageHeight)
\n    geometry.setTexCoord1(pointIndex, u, v)  
\n  
\n  while True:
\n    
\n    # Capture image
\n    screenshot = ImageGrab.grab(bbox=(comp.Left, comp.Top, comp.Right, comp.Bottom))    
\n    screenshot.save(comp.TargetImage[8:])
\n    
\n    # Show image
\n    material = app.createMaterial(\"WindowPlayer\")   
\n    app.addMaterial(material) 
\n    material.Diffuse = vcVector.new(1.0, 1.0, 1.0)    
\n    texture = app.loadBitmap(comp.TargetImage)
\n    material.Texture = texture    
\n    
\n    # Rebuild
\n    geometry.Material = material    
\n    block.rebuild()
\n    
\n    delay(sim.SimSpeed)
\n
\ndef OnCaptureTopLeft(arg):
\n  while True:
\n    # When middle button is pressed
\n    if windll.user32.GetAsyncKeyState(0x04) != 0:
\n      cursor = wintypes.POINT()
\n      windll.user32.GetCursorPos(byref(cursor))
\n      comp.Left = cursor.x
\n      comp.Top = cursor.y
\n      break
\n    # VC will be freezed, which is normal
\n    time.sleep(0.1)
\n    
\ncaptureTopLeft = comp.getProperty(\"CaptureTopLeft\")
\ncaptureTopLeft.OnChanged = OnCaptureTopLeft
\n
\ndef OnCaptureBottomRight(arg):
\n  while True:
\n    # When middle button is pressed
\n    if windll.user32.GetAsyncKeyState(0x04) != 0:
\n      cursor = wintypes.POINT()
\n      windll.user32.GetCursorPos(byref(cursor))
\n      comp.Right = cursor.x
\n      comp.Bottom = cursor.y
\n      break
\n    # VC will be freezed, which is normal
\n    time.sleep(0.1)
\n    
\ncaptureBottomRight = comp.getProperty(\"CaptureBottomRight\")
\ncaptureBottomRight.OnChanged = OnCaptureBottomRight"
CompatibilityMode 0
}
VCID f593a259-70a8-482a-925f-06ef7c71bc3d
OriginalUri vcid:f593a259-70a8-482a-925f-06ef7c71bc3d
Revision 0
Location 1 0 0 0 0 1 0 0 0 0 1 0 0 0 0 1 
ActiveSimulationLevel detailed
BOMname  "DesktopPlayer"

BOMdescription  ""

Category  ""

VariableSpace ""
{
  Variable "rTVariable<rBool>"
  {
    Name "Visible"
    Value 1
    Group -1130
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
    }
  }
  Variable "rTVariable<rInt>"
  {
    Name "Top"
    Value 315
    Group 30
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rInt>"
  {
    Name "Left"
    Value 2177
    Group 40
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rInt>"
  {
    Name "Bottom"
    Value 979
    Group 50
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rInt>"
  {
    Name "Right"
    Value 3059
    Group 60
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rButton>"
  {
    Name "CaptureTopLeft"
    Value 0
    Group 80
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rButton>"
  {
    Name "CaptureBottomRight"
    Value 1
    Group 90
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rUri>"
  {
    Name "TargetImage"
    Value "file:///D:/DesktopPlayer.png"
    Group 100
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rDouble>"
  {
    Name "Scale"
    Value 5
    Group 120
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      ON_EDIT_REBUILD
      TRANSLATE_USING_GETTEXT
    }
  }
}
}
